<!DOCTYPE html>
<html lang="es">
<!--
  PAGINA DE RESEÑAS CON LAS OPINIONES Y VALORACIONES
  DE LOS USUARIOS DE CADA UNO DE LOS LUGARES
-->

<head>
  <meta charset="UTF-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Opiniones</title>
  <link rel="stylesheet" href="css/review_header.css" />
  <link rel="stylesheet" href="css/reviews.css" />
  <link rel="stylesheet" href="css/review_bar.css" />
  <link rel="stylesheet" href="css/review_detailed.css" />
  <script src="scripts/utils.js"></script>
  <script src="scripts/users.js"></script>
  <script src="scripts/places.js"></script>
  <script>
    // Obtener la cadena de consulta de la URL
    var queryString = window.location.search;

    var urlParams = new URLSearchParams(queryString);

    // Obtener el valor de un parámetro
    if (places.has(urlParams.get("id"))) {
      //las variables en javascript tiene ambito de funcion o global
      // si quieres variable local debes usar "let"
      var place = places.get(urlParams.get("id"));
    }
  </script>
</head>

<body>
  <header>
    <!--
        esta barra es parecida a la de aplicaciones principal de
        nuestro sitio web, con la salvedad que tiene un boton de icono
        que en teoría nos deja ver si este sitio es un favorito o no
        y nos lo dejaría quitar de favoritos, esto al requerir javascript
        y modificar el archivo json que representa a la base de datos
        no se ha hecho porque he querido hacer todos los eventos con CSS
      -->
    <div id="review-bar">
      <a href="index.html">
        <div class="BackButton"></div>
      </a>
      <div class="Title">
        <script>
          $("#review-bar .Title")
            .textContent = place.title;
        </script>
      </div>
      <div class="IconButton">
        <script>
          if (place.isFavorite) {
            $("#review-bar .IconButton")
              .classList.add("HeartFilled");
          } else {
            $("#review-bar .IconButton")
              .classList.add("HeartOutlined");
          }
        </script>
      </div>
      <div id="config"></div>
    </div>
  </header>
  <section id="subheader">
    <!--
        representa la cabecera de la páginas de reseñas
        aquí estan las fotos, el numero de opiniones o reseñas
        y la nota media del lugar sacada de las valoraciones de la gente
        Ademas tiene un background con la imagen principal del lugar

        Para hacer el scroll se puede usar la barra de desplazamiento
        pero quise meter también unos botones a los lados, que en
        muchos sitios no se ven pero que si pulsas en los laterales
        te desplazan el contenido, esta habilidad de hacer scroll
        en un elemento realmente no es visual y no está asociado
        directamente al style del elemento
      -->
    <div id="review-header">
      <div class="Background">
        <script>
          $("#review-header .Background")
            .style.backgroundImage = `url(images/photos/${place.image})`;
        </script>
      </div>
      <div class="Top">
        <div class="Left"
          onclick="scrollToLeft('#review-header .Top', 100)">
        </div>
        <template id="tmpPhotoThumbnail">
          <div class="PhotoThumbnail">
            <label for="photo_11" class="Content">
              <img src="" alt="aqui va la miniatura" />
            </label>
            <input type="checkbox" id="photo_11" />
          </div>
        </template>
        <template id="tmpPhotoPreview">
          <div class="PhotoPreview">
            <div class="Top">
              <label for="photo_11" class="Close"> </label>
            </div>
            <div class="Bottom">
              <img src="" alt="aqui va la foto grande" />
            </div>
          </div>
        </template>
        <div class="Right"
          onclick="scrollToRight('#review-header .Top', 100)">
        </div>
      </div>
      <div class="Bottom">
        <div class="Left">
          <div class="Title">
            <script>
              $("#review-header .Bottom .Left .Title")
                .textContent = place.reviews.length;
            </script>
          </div>
          <div class="Subtitle">VALORACIONES</div>
        </div>
        <div class="Right">
          <div class="Title">
            <script>
              $("#review-header .Bottom .Right .Title")
                .textContent = place.rating;
            </script>
          </div>
          <div class="Subtitle">
            <!--
                Como curiosidad le asignamos un valor a una variable
                con la notación --variable que luego el css podrá utilizar
               -->
            <div class="RatingBar">
              <script>
                $("#review-header .Bottom .Right .Subtitle")
                  .style.setProperty("--value", place.rating);
              </script>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
  <main>
    <div id="reviews">
      <!--
          Esta es la tarjeta de cada reseña, opinion
          que esta compuesta de una parte superior donde van
          el titulo, la valoracion(nota) y autor y fecha

          En la parte de abajo va un resumen y el texto con la opinion
          por defecto acorta el texto y lo expande si lo queremos
          leer completo.
          Para simular esto usamos label e inputs que representan
          dos estados y con css podemos visualizar u ocultar
          elementos

          En la fecha usamos time para ayudar a los buscadores
        -->
      <template id="tmpReview">
        <label for="1" class="ReviewDetailed">
          <input type="checkbox" id="1" />
          <div class="Top">
            <div class="Left">
              <div class="Title">Regalo de los dioses</div>
              <div class="Rating">
                <div class="RatingBar" style="--value: 7.5"></div>
                <span class="Value">7.77</span>
              </div>
              <div class="Subtitle">
                <div class="Author">Daniel</div>
                <time datetime="2024-02-09" class="Date">09 feb 2024</time>
              </div>
            </div>
            <div class="Right">
              <div class="Avatar"></div>
            </div>
          </div>
          <div class="Bottom">
            <div class="Summary">
              <div class="Title">
                Machu picchu es un regalo para los sentidos. la ve
              </div>
              <div class="Subtitle">mostrar más</div>
            </div>
            <div class="Content">
              Machu picchu es un regalo para los sentidos. la vegetación
              exhuberante, los picos montañosos imponentes y las ruinas
              evocadoras crean una experiencia multisensorial.
            </div>
          </div>
        </label>
      </template>
      <script>
        const limitContent = 100;
        for (var i = 0; i < place.reviews.length; i++) {
          var review = place.reviews[i];
          // Clonar la plantilla
          const reviewElement = $("#tmpReview")
            .content.cloneNode(true);

          reviewElement.querySelector("label")
            .htmlFor = review.id;
          reviewElement.querySelector('input[type="checkbox"]')
            .id = review.id;
          reviewElement.querySelector(".Top .Title")
            .textContent = review.title;
          reviewElement.querySelector(".Summary .Title")
            .textContent = review.content.substring(0, limitContent);
          reviewElement.querySelector(".Content")
            .textContent = review.content;
          reviewElement.querySelector(".Author")
            .textContent = users.get(review.author).name;
          reviewElement.querySelector(".Avatar")
            .style.backgroundImage = `url(${users.get(review.author).avatar})`;
          reviewElement.querySelector(".Date")
            .textContent = review.date;
          reviewElement.querySelector(".Date")
            .datetime = review.date;
          reviewElement.querySelector(".Rating .RatingBar")
            .style.setProperty("--value", review.rating);
          reviewElement.querySelector(".Rating .Value")
            .textContent = review.rating;

          // esto sirve para saber si el tamaño de la opinion
          // es mayor o menor que la permitida
          // como por defecto se pone el mostrar más
          // oculta el mostrar más sólo si la opinión es muy corta
          if (limitContent >= review.content.length) {
            reviewElement.querySelector(".Summary .Subtitle")
              .style.visibility = "hidden";
            reviewElement.querySelector('input[type="checkbox"]')
              .disabled = true;
          }

          // Para iterar por las imágenes de cada reseña
          // ya que quien pone las imágenes son los usuarios
          // y no sirve para componer las miniaturas y las preview
          // del header
          if (review.images) {
            for (var imagePath of review.images) {
              const thumbnail = $("#tmpPhotoThumbnail")
                .content.cloneNode(true);

              thumbnail.querySelector(".PhotoThumbnail .Content")
                .htmlFor = `photo_${imagePath}`;
              thumbnail.querySelector('.PhotoThumbnail input[type="checkbox"]')
                .id = `photo_${imagePath}`;
              thumbnail.querySelector(".PhotoThumbnail img")
                .src = `./images/photos/${place.id}_${imagePath}.avif`;

              $("#review-header .Top")
                .appendChild(thumbnail);

              const preview = $("#tmpPhotoPreview")
                .content.cloneNode(true);
              preview.querySelector(".PhotoPreview .Close")
                .htmlFor = `photo_${imagePath}`;
              preview.querySelector(".PhotoPreview img")
                .src = `./images/photos/${place.id}_${imagePath}.avif`;

              $("#review-header .Top")
                .appendChild(preview);
            }
          }

          $("#reviews").appendChild(reviewElement);
        }
      </script>
    </div>
  </main>
</body>

</html>